﻿using ApiDePaul.DTO;
using Microsoft.AspNetCore.Mvc;
using Model;
using StubLib;
using System.Collections.Generic;

namespace ApiDePaul.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class ChampionController : ControllerBase
    {
        private readonly ILogger<ChampionController> _logger;

        public ChampionController(ILogger<ChampionController> logger)
        {
            _logger = logger;
        }
        
        [HttpGet]
        public async Task<ActionResult<ChampionDto>> Get()
        {
            StubData stu = new StubData();

            IEnumerable<Champion?> lcha = await stu.ChampionsMgr.GetItems(0, stu.ChampionsMgr.GetNbItems().Result);
          
            List<ChampionDto> champs = new List<ChampionDto>();

            lcha.ToList().ForEach(c => champs.Add(c.ChampToDto()));
            return Ok(champs);
        }

        [HttpGet("{id}")]
        public async Task<ActionResult<ChampionDto>> Get(int id)
        {
            StubData stu = new StubData();

            
            IEnumerable<Champion?> lcha = await stu.ChampionsMgr.GetItems(id, 1);
            
            if (id >= 0 && id < stu.ChampionsMgr.GetNbItems().Result)
            {
                return Ok(lcha.First().ChampToDto());
            }
            return BadRequest();
        }
        /*
        // GET: ChampionController/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: ChampionController/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: ChampionController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: ChampionController/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: ChampionController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: ChampionController/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: ChampionController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }*/
    }
}
